#ifdef USE_DOUBLES
typedef double float_type;
#else
typedef float float_type;
#endif


class IKmeans{
private:
    int k;
    int max_iterations;
    float_type *data;
    int num_points;
    int wavelets_per_point;
    int wavelet_length;
    int *cluster_assignments;
    float_type *centroids;
    int *points_per_cluster;
    int *coeffs_lengths;
    int num_levels;
    int current_level;
    int point_offset;

    void recalculate_centroids(int resolution);
    float_type distance(const float_type *p1, const float_type *p2, int used_resolution);

public:
    IKmeans(int k, int max_iterations,
        float_type *data, int num_points, int wavelets_per_point, int wavelet_length,
        int *cluster_assignments, float_type *centroids, int *points_per_cluster,
        int *coeffs_lengths, int num_levels, int current_level
    );
    int cluster();

};
