#ifdef USE_DOUBLES
typedef double float_type;
#else
typedef float float_type;
#endif

#include <pybind11/pybind11.h>
#include <pybind11/numpy.h>
#include <pybind11/stl.h>
#include <string>

namespace py = pybind11;

class Incremental_clustering{

    bool write_data_to_files(int num_points, std::vector<std::string> point_ids, int *cluster_assignments, float_type threshold, int start_with_levels, int num_levels, int k, int iterations, bool converged, std::string tag, int dim);

public:
    int cluster(py::array_t<float_type, py::array::f_style | py::array::forcecast> wavelet_data,
        std::vector<std::string> point_ids,
        py::array_t<int, py::array::f_style | py::array::forcecast> coeff_lengths_data, //-''-
        int num_points, int wavelets_per_point, int wavelet_length, float_type threshold, int branchingfactor,
        int num_levels /*number of resolution levels in the wavelets*/, int start_with_levels, /*number of levels that should be used for building the CFTree*/
        int max_iterations, /*maximum number of iterations for incremental k-means*/
        std::string tag //tag to be appended to the output file name
    );

};
